GNU bug report logs - #45613
U2F does not work in IceCat

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: John Doe <likeslisp@HIDDEN>; dated Sat, 2 Jan 2021 19:42:02 UTC; Maintainer for guix is bug-guix@HIDDEN.

Message received at 45613 <at> debbugs.gnu.org:


Received: (at 45613) by debbugs.gnu.org; 11 Oct 2021 14:12:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 11 10:12:32 2021
Received: from localhost ([127.0.0.1]:60548 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1mZw2Z-00022F-UH
	for submit <at> debbugs.gnu.org; Mon, 11 Oct 2021 10:12:32 -0400
Received: from mail-ed1-f54.google.com ([209.85.208.54]:33638)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raphael.melotte@HIDDEN>) id 1mZw2X-000220-Aq
 for 45613 <at> debbugs.gnu.org; Mon, 11 Oct 2021 10:12:30 -0400
Received: by mail-ed1-f54.google.com with SMTP id p13so69036576edw.0
 for <45613 <at> debbugs.gnu.org>; Mon, 11 Oct 2021 07:12:29 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=mind.be; s=google;
 h=to:from:message-id:date:user-agent:mime-version:content-language
 :content-transfer-encoding;
 bh=jFbDE/J1zJ7E0JeSLgGMcNu1sgK3+VFrPgbHHeQvl90=;
 b=IAyC7k6IxGD2ItHjLXzkWWg3Js9ScTJxSXUcHUNHeK/WucNm8vBYn1MooiYFigqyrt
 CT1w/W+BJhxPL/PUztHbt/WYetDA6DfIUAMDAiaLngXLgx/rytYWKaSgVjUIMWhDuKOe
 7kFXOrYo6j7fTwZi0xtHtltCwdPNiUQYVulyXgozI5up0bwPkzGUpK9SnhA+httxhgcI
 571SsK8kn8rfE1rKzAaESSnJ4x6vluSApVZQhKSbRXSFBHMfdLsSK9jplBhWBtjxjfnc
 7j/6ACorT6gf5nKz0e9LarV/ovGidmiNDI/c6lAPl93XbhT6ml38d7b6LshRl5Jfkzxj
 rn4w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:to:from:message-id:date:user-agent:mime-version
 :content-language:content-transfer-encoding;
 bh=jFbDE/J1zJ7E0JeSLgGMcNu1sgK3+VFrPgbHHeQvl90=;
 b=4b4rnEKc7obchkFuPzK77yVmerW1C7smz7itexG4xm7D8BHOZr4DMGZ7iV2j9B8ZqF
 ljZZ1eST/Q/hs8cDbG4lY69rM6Ocn2iOsFDerNMPe8ra+r0dU02cT1XtpUWxkBoNk+zZ
 JPXoQdfd0rJLm2vGJORTgws9j/XTmdCtLxx5r7P2gtv+/oTUtpiZ7YCtjnveR85cOX37
 pXoSSgezW228q0sKJkdhRxuoPbb6bHdlM9otrnZMItEnX63MLUGdyjvDszhRFON3+32v
 GFWFRdYkybgDYED2e5tw1vI7iauoYSyZqpBZcOC6VhQRFOZLdJ0UQkaYtH4pVGdZNyjZ
 5/jQ==
X-Gm-Message-State: AOAM531GVDRTL0kCreTlQDP7XNgBA5y/l+MuX7KWadqUK3hBUKK3aEEm
 R5z22jWqEwMxxnNYnU8gdahct4FIZjLwTmr7
X-Google-Smtp-Source: ABdhPJxYMDdUGxLGAvILzu6sttW+5TgK0BFRSa3+m7U181AAErTiAtOKpUdzEBPNHokC4FXCos5EIA==
X-Received: by 2002:a05:6402:350c:: with SMTP id
 b12mr42033146edd.244.1633961543285; 
 Mon, 11 Oct 2021 07:12:23 -0700 (PDT)
Received: from [192.168.1.30] (5.26-130-109.adsl-dyn.isp.belgacom.be.
 [109.130.26.5])
 by smtp.gmail.com with ESMTPSA id e7sm4572275edk.3.2021.10.11.07.12.22
 for <45613 <at> debbugs.gnu.org>
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 11 Oct 2021 07:12:23 -0700 (PDT)
To: 45613 <at> debbugs.gnu.org
From: =?UTF-8?B?UmFwaGHDq2wgTcOpbG90dGU=?= <raphael.melotte@HIDDEN>
Message-ID: <87c35008-8c85-a46b-269d-0aad30731352@HIDDEN>
Date: Mon, 11 Oct 2021 16:12:22 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:78.0) Gecko/20100101
 Firefox/78.0 Thunderbird/78.14.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 2.2 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: To me it looks like this bug is now solved. I remember having
 the same problem months ago, but today it seems to work fine (on a foreign
 distro). Guix: --- guix 6eded1a repository URL:
 https://git.savannah.gnu.org/git/guix.git
 branch: master commit: 6eded1a04186e3118b293486b038c994e05efedf --- 
 Content analysis details:   (2.2 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.208.54 listed in wl.mailspike.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.208.54 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
 mail domains are different
 1.8 MISSING_SUBJECT        Missing Subject: header
 0.2 NO_SUBJECT             Extra score for no subject
X-Debbugs-Envelope-To: 45613
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.2 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  To me it looks like this bug is now solved. I remember having
    the same problem months ago, but today it seems to work fine (on a foreign
    distro). Guix: --- guix 6eded1a repository URL: https://git.savannah.gnu.org/git/guix.git
    branch: master commit: 6eded1a04186e3118b293486b038c994e05efedf --- 
 
 Content analysis details:   (1.2 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.208.54 listed in wl.mailspike.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.208.54 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
                             mail domains are different
  1.8 MISSING_SUBJECT        Missing Subject: header
  0.2 NO_SUBJECT             Extra score for no subject
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

To me it looks like this bug is now solved.

I remember having the same problem months ago, but today it seems to work fine 
(on a foreign distro).

Guix:
---
   guix 6eded1a
     repository URL: https://git.savannah.gnu.org/git/guix.git
     branch: master
     commit: 6eded1a04186e3118b293486b038c994e05efedf
---

Icecat:
---
icecat                  78.14.0-guix0-preview1  out 
/gnu/store/xwzp1lj8b429yc9nbx3nwy1ia9r1sr2x-icecat-78.14.0-guix0-preview1
---

It worked both with https://u2f.bin.coffee/ and other services.

Note that I'm "cheating" a little bit though: I'm using an emulated device, not 
an actual USB device (but the same emulated device previously didn't work with a 
Guix-built icecat).





Information forwarded to bug-guix@HIDDEN:
bug#45613; Package guix. Full text available.

Message received at 45613 <at> debbugs.gnu.org:


Received: (at 45613) by debbugs.gnu.org; 3 Jan 2021 17:19:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jan 03 12:19:26 2021
Received: from localhost ([127.0.0.1]:38518 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kw72L-0007Kc-U0
	for submit <at> debbugs.gnu.org; Sun, 03 Jan 2021 12:19:26 -0500
Received: from mail-40132.protonmail.ch ([185.70.40.132]:22058)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <likeslisp@HIDDEN>) id 1kw72I-0007KK-61
 for 45613 <at> debbugs.gnu.org; Sun, 03 Jan 2021 12:19:24 -0500
Date: Sun, 03 Jan 2021 17:19:07 +0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=protonmail.com;
 s=protonmail; t=1609694355;
 bh=R7/CaAwvUvEL55Uyfr+hk4ymcVqnDUG7xRuu9YiTkug=;
 h=Date:To:From:Reply-To:Subject:From;
 b=llv6bqm1o/dTXTc5LlKnvIQcrvG2ALfLWiTeJfwh5nxq9kwDLG2DH5Mo3JX/CdYG0
 2tia1GlshNHtyeBV7wjv/iT+bZarax8MAKcOqYk0H0L8AiSFKYwlV7BaBv55pvI/X6
 bQoLbA4Eh8XLPDSz5InQYJ1oSbq/b4NrGDxmegxM=
To: "45613 <at> debbugs.gnu.org" <45613 <at> debbugs.gnu.org>
From: John Doe <likeslisp@HIDDEN>
Subject: (No Subject)
Message-ID: <ajINObAdvYYUK_YKE9TetKsQaLg0PgihufdMYKeL8ohi2WGN44ErcWIKkgaXisaYKJn7P8I4P9bV9s90qZ8cf7OSE0xPgHgAB9lfyMgaYgA=@protonmail.com>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Status: No, score=-1.2 required=10.0 tests=ALL_TRUSTED,DKIM_SIGNED,
 DKIM_VALID,DKIM_VALID_AU,DKIM_VALID_EF,FREEMAIL_FROM shortcircuit=no
 autolearn=disabled version=3.4.4
X-Spam-Checker-Version: SpamAssassin 3.4.4 (2020-01-24) on
 mailout.protonmail.ch
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: Forgot to mention in the original report: The issue is very
 similar to the following bug:
 https://debbugs.gnu.org/cgi/bugreport.cgi?bug=38341
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 2.0 SLIGHTLY_BAD_SUBJECT   Subject contains something slightly spammy
 -0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [185.70.40.132 listed in wl.mailspike.net]
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: protonmail.com]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (likeslisp[at]protonmail.com)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 45613
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: John Doe <likeslisp@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Forgot to mention in the original report: The issue is very similar to the =
following bug: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D38341




Information forwarded to bug-guix@HIDDEN:
bug#45613; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Jan 2021 19:41:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 02 14:41:54 2021
Received: from localhost ([127.0.0.1]:60970 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kvmmc-0008Ks-6K
	for submit <at> debbugs.gnu.org; Sat, 02 Jan 2021 14:41:54 -0500
Received: from lists.gnu.org ([209.51.188.17]:32858)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <likeslisp@HIDDEN>) id 1kvmmZ-0008Kj-Hs
 for submit <at> debbugs.gnu.org; Sat, 02 Jan 2021 14:41:48 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:59640)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <likeslisp@HIDDEN>)
 id 1kvmmZ-0006r3-Aa
 for bug-guix@HIDDEN; Sat, 02 Jan 2021 14:41:47 -0500
Received: from mail-40135.protonmail.ch ([185.70.40.135]:58866)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <likeslisp@HIDDEN>)
 id 1kvmmW-00088x-EI
 for bug-guix@HIDDEN; Sat, 02 Jan 2021 14:41:46 -0500
Date: Sat, 02 Jan 2021 19:41:35 +0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=protonmail.com;
 s=protonmail; t=1609616498;
 bh=VD98+icZjZytbomi4DTxxU9hkWwpXyja6WbIFCRf/Tk=;
 h=Date:To:From:Reply-To:Subject:From;
 b=BAsjxetj+1uz+0Z5/+IMtTfMhbTxKWxPbCKP4Cqiq3s53CEahYafLaNoUmsukoWJs
 LA2Goa97eY9TvbC33wI9O3qHuGVX00XWO8gf4yuIX63EyJiSKEC0sDZwqBLIfCtGEv
 vF47lL2SGUPCvFOFotJEDpDtDUbsxKwTJmtrY0nA=
To: "bug-guix@HIDDEN" <bug-guix@HIDDEN>
From: John Doe <likeslisp@HIDDEN>
Subject: U2F does not work in IceCat
Message-ID: <gn_7cTM1ikqOoRzLBLy1r_ldz7hM3tf0deNZovokbNQKw4VIz5toV3Z8M3l5ceyqZ5kufdfruV7krS09d5FyQuuwhoRtBX9MzIjqiFrzKgg=@protonmail.com>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Status: No, score=-1.2 required=10.0 tests=ALL_TRUSTED,DKIM_SIGNED,
 DKIM_VALID,DKIM_VALID_AU,DKIM_VALID_EF,FREEMAIL_FROM shortcircuit=no
 autolearn=disabled version=3.4.4
X-Spam-Checker-Version: SpamAssassin 3.4.4 (2020-01-24) on
 mailout.protonmail.ch
Received-SPF: pass client-ip=185.70.40.135;
 envelope-from=likeslisp@HIDDEN; helo=mail-40135.protonmail.ch
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_MSPIKE_H4=0.001, RCVD_IN_MSPIKE_WL=0.001, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: John Doe <likeslisp@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

I've been trying to get U2F to work in IceCat without success with the Nitr=
okey FIDO2 and FIDO U2F devices. To test 2 websites were used: vault.bitwar=
den.com and u2f.bin.coffee .

For vault.bitwarden.com, after entering the password, the following error p=
opup appears repeatedly:
"An error has occurred. U2F Error: 1"

For u2f.bin.coffee, when clicking the U2F Register button, the following er=
ror appears:
"
Sending request with appId: https://u2f.bin.coffee
{
  "version": "U2F_V2",
  "challenge": "pyvBtAPUygH0mZg4_thmdo_Ltnk"
}

Got response:
{
  "errorCode": 1
}

[FAIL] Imported credential public key
Failures: 1 TODOs: 0
"
A similar error appears for the U2F Sign button.

The same websites work without trouble in ungoogled-chromium as well as Fir=
efox installed in Flatpak and run with the options "flatpak run --user --de=
vice=3Dall org.mozilla.firefox".

I have installed the pam-u2f package which includes the libu2f-server and l=
ibu2f-host packages.

In /etc/config.scm I have the following configuration to add udev rules for=
 the Nitrokey device:

"
(use-modules (guix download)
             (guix packages)
(use-service-modules security-token)
;; ...
(define %nitrokey-udev-rule
  (file->udev-rule
   "41-nitrokey.rules"
   (let ((version "2019"))
     (origin
      (method url-fetch)
      (uri "https://raw.githubusercontent.com/Nitrokey/libnitrokey/master/d=
ata/41-nitrokey.rules")
      (sha256
       (base32 "1j8x9i2ypr6jadpmjbcffk7rjqd3a4x0krqx5hqk7bfgsxzima23"))))))

;; ref. https://lists.gnu.org/archive/html/help-guix/2019-07/msg00051.html
(define %updated-desktop-services
  (modify-services
   %desktop-services
   (udev-service-type config =3D>
                      (udev-configuration
                       (inherit config)
                       (rules (append (udev-configuration-rules config)
                                      (list %nitrokey-udev-rule)))))))

(operating-system
 ;; ...
 (services
  (append
   (list
    (service xfce-desktop-service-type)
    (set-xorg-configuration
     (xorg-configuration
      (keyboard-layout keyboard-layout))))
   (list
    ;; ...
    (service pcscd-service-type))
   %updated-desktop-services))
 ;; ...
"

Please let me know if there is any additional information I can provide.




Acknowledgement sent to John Doe <likeslisp@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#45613; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 11 Oct 2021 14:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.